%define name        mx4j
%define version     3.0.1
%define release     1jpp_4rh
%define section     free

%define jmx_version     1.2.1

Name:           %{name}
Version:        %{version}
Release:        %{release}
Epoch:		1
Summary:        Open source implementation of JMX Java API
License:        Apache License
Group:          Development/Libraries/Java
#Vendor:     	JPackage Project
#Distribution:   JPackage
Source0:        %{name}-%{version}-src.tar.gz
Source1:        %{name}-build.policy
Source2:        CatalogManager.properties
Patch0:         mx4j-javaxssl.patch
Patch1:         mx4j-%{version}.patch
Patch2:         mx4j-%{version}-build.patch
Patch3:         mx4j-docbook.patch
#Patch4:         mx4j-docbook-style.patch
# We don't ship WebWorks so we remove caucho from tools
Patch5:         mx4j-caucho-build.patch
Url:            http://mx4j.sourceforge.net/
BuildRequires:  jpackage-utils > 1.5.38
BuildRequires:  ant >= 1.6
BuildRequires:  ant-trax
#BuildRequires:  burlap
#BuildRequires:  hessian
BuildRequires:	jaf
BuildRequires:	javamail
#BuildRequires:	jetty4
BuildRequires:	jython >= 2.1
BuildRequires:	log4j >= 1.2.7
BuildRequires:	jakarta-commons-logging >= 1.0.1
BuildRequires:  xml-commons-apis
BuildRequires:  bcel >= 5.0
BuildRequires:	jsse >= 1.0.2-6jpp
BuildRequires:	jce >= 1.2.2
#BuildRequires:	jmx >= 1.2
#BuildRequires:	jmxremote >= 1.0
BuildRequires:	junit >= 3.7.1
BuildRequires:  coreutils
BuildRequires:  xjavadoc
BuildRequires:  xdoclet
BuildRequires:  axis >= 1.1
BuildRequires:  docbook-dtds >= 1.0
BuildRequires:  docbook-style-xsl >= 1.61
BuildRequires:  xml-commons-resolver
BuildRequires:  xml-commons
#BuildRequires:  xmlunit
Buildarch:      noarch
Requires(preun):  /usr/sbin/update-alternatives
Requires(post):  /usr/sbin/update-alternatives
Requires:	jaf
Requires:	javamail
Requires:	log4j >= 1.2.7
Requires:	jakarta-commons-logging >= 1.0.1
Requires:  	xml-commons-apis
Requires:  	bcel >= 5.0
Requires:	jsse >= 1.0.2-6jpp
Requires:	jce >= 1.2.2
Requires:  	axis >= 1.1
Requires:  	xml-commons-resolver
Requires:  	xml-commons
Buildroot:      %{_tmppath}/%{name}-%{version}-buildroot
Obsoletes:      openjmx
Provides:	jmxri = 0:%{jmx_version}

%description
OpenJMX is an open source implementation of the
Java(TM) Management Extensions (JMX).

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Obsoletes:      openjmx-javadoc

%description javadoc
Javadoc for %{name}.

%package manual
Group:          Development/Libraries/Java
Summary:        Documentation for %{name}

%description    manual
Documentation for %{name}.

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q

%patch0 -p1
%patch1 -p0
%patch2 -p1
%patch3 -p1
#%patch4 -p1
%patch5 -p1

cp %{SOURCE1} build
#cp %{SOURCE2} build
cp %{_sourcedir}/CatalogManager.properties %{_builddir}/%{name}-%{version}/build/

pushd lib
   ln -sf $(build-classpath junit) .
#   ln -sf $(build-classpath xmlunit) .
   ln -sf $(build-classpath xml-commons-apis) xml-apis.jar
   ln -sf $(build-classpath xerces-j2) xercesImpl.jar
   ln -sf $(build-classpath xalan-j2) xalan.jar
   ln -sf $(build-classpath commons-logging) .
   ln -sf $(build-classpath log4j) .
   ln -sf $(build-classpath bcel) .
#   ln -sf $(build-classpath burlap) .
#   ln -sf $(build-classpath hessian) .
   ln -sf $(build-classpath axis/axis) .
   ln -sf $(build-classpath axis/jaxrpc) .
   ln -sf $(build-classpath axis/saaj) .
   ln -sf $(build-classpath wsdl4j) .
   ln -sf $(build-classpath commons-discovery) .
#   ln -sf $(build-classpath jetty4) org.mortbay.jetty.jar
   ln -sf $(build-classpath servletapi5) servlet.jar
   ln -sf $(build-classpath jython) .
   ln -sf $(build-classpath jsse) .
   ln -sf $(build-classpath jsse/jcert) .
   ln -sf $(build-classpath jsse/jnet) .
   ln -sf $(build-classpath jaas) .
#   ln -sf $(build-classpath jmxri) .
#   ln -sf $(build-classpath jmxremoteri) jmxremote.jar
#   ln -sf $(build-classpath jmxremoteri-optional) jmxremote_optional.jar
popd

%build
export ANT_OPTS="-Djava.security.manager -Djava.security.policy=$(pwd)/build/mx4j-build.policy"
#export OPT_JAR_LIST="ant/ant-junit junit xmlunit ant/ant-trax jaxp_transform_impl"
export CLASSPATH=$(build-classpath activation javamail \
   jython jakarta-commons-logging xml-commons-apis bcel jsse jaas jce \
   log4j jaxp_transform_impl axis/axis axis/jaxrpc axis/saaj \
   xml-commons-resolver xdoclet/xdoclet xdoclet/xdoclet-jmx-module \
   xdoclet/xdoclet-mx4j-module)

export CLASSPATH=${CLASSPATH}:%{_builddir}/%{name}-%{version}/classes/core:%{_builddir}/%{name}-%{version}/build

cd build
#ant -Dbuild.sysclasspath=first tests-report javadocs docs
ant compile.jmx compile.rjmx compile.tools javadocs docs

%install
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 dist/lib/%{name}-impl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-impl-%{version}.jar
install -m 644 dist/lib/%{name}-jmx.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jmx-%{version}.jar
install -m 644 dist/lib/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar
install -m 644 dist/lib/%{name}-tools.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-tools-%{version}.jar
install -m 644 dist/lib/%{name}-rjmx.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-rjmx-%{version}.jar
install -m 644 dist/lib/%{name}-rimpl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-rimpl-%{version}.jar
install -m 644 dist/lib/%{name}-remote.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-remote-%{version}.jar

pushd $RPM_BUILD_ROOT%{_javadir}/%{name}
   for jar in *-%{version}.jar ; do
      ln -fs ${jar} $(echo $jar | sed "s|-%{version}.jar|.jar|g")
   done
popd

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -r dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%pre
rm -f %{_javadir}/%{name}.jar

%post
/usr/sbin/update-alternatives --install %{_javadir}/jmxri.jar jmxri %{_javadir}/%{name}/%{name}-jmx.jar 10201

%postun
if [ "$1" = "0" ]; then
	/usr/sbin/update-alternatives --remove jmxri %{_javadir}/%{name}/%{name}-jmx.jar
fi


%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}

%files manual
%defattr(0644,root,root,0755)
%doc dist/docs/*

%changelog
* Thu Nov 17 2005 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-1jpp_4rh
- Use generic javamail alternative
- JMX spec version implemented is 1.2.1

* Wed Nov 16 2005 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-1jpp_3rh
- New 6-digit alternative priority

* Fri Apr 22 2005 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-1jpp_2rh
- Add patch for "patch for java.naming.corba.orb"
- Build without POA

* Fri Apr 22 2005 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-1jpp_1rh
- Merge with upstream for upgrade

* Fri Apr 22 2005 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-1jpp
- Upgrade to 3.0.1

* Wed Apr 20 2005 Fernando Nasser <fnasser@redhat.com> 0:2.1.0-1jpp
- Upgrade to 2.1.0
- Do not build caucho part because of version incompatibilities

* Tue Mar 08 2005 Ralph Apel <r.apel at r-apel.de> 0:2.0.1-3jpp
- Drop spurious Requires: junit

* Wed Oct 27 2004 Fernando Nasser <fnasser@redhat.com> 0:2.0.1-2jpp_1rh
- Merge with upstream for upgrade to 2.0.1
- Correctly specify CatalogManager.properties as a source file
- Deactivate jython- and jetty-related classes
- Disable unit tests, therefore NOT BuildReq xmlunit
- Disable compliance test, therefore NOT BuildReq jmx, jmxremote

* Fri Oct 1 2004 Andrew Overholt <overholt@redhat.com> 1:1.1.1-4jpp_4rh
- add coreutils BuildRequires

* Fri Sep 24 2004 Ralph Apel <r.apel at r-apel.de> 0:2.0.1-2jpp
- Require xml-commons (jpackage), not xml-common (linux)
- Activate jython- and jetty-related classes
- Activate unit tests, therefore BuildReq xmlunit
- Include compliance test, therefore BuildReq jmx, jmxremote
- Define essential runtime requires
- Use security manager and relaxed policy

* Fri Jun 25 2004 Aizaz Ahmed <aahmed@redhat.com> 1:2.0.1-1jpp
- Updated to use mx4j-2.0.1
- Rebuilt with Ant 1.6.2

* Wed Mar 31 2004 Frank Ch. Eigler <fche@redhat.com> 1:1.1.1-4jpp_3rh
- bump up epoch for RHUG upgrading

* Fri Mar 26 2004 Frank Ch. Eigler <fche@redhat.com> 0:1.1.1-4jpp_2rh
- add RHUG upgrade cleanup

* Thu Mar 11 2004 Frank Ch. Eigler <fche@redhat.com: 0:1.1.1-4jpp_1rh
- RH vacuuming
- added mx4j-javaxssl.patch to use javax.net.* instead of com.sun.net.*

* Mon Mar 24 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.1.1-4jpp
- jmxri alternative

* Mon Mar 24 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.1.1-3jpp
- use own dir
- For jpackage-utils 1.5

* Thu Feb 20 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.1.1-1jpp
- mx4j 1.1.1
- grabed from CVS TAG MX4J_1_1_1

* Wed Sep 18 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.1-3jpp
- added missing xsl/jython resources in mx4j-tools.jar
- correct the build.xml to have correct contents for mx4.jar and mx4j-tools.jar

* Tue Jul 02 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.1-2jpp
- bzipped additional sources
- section macro
- ant already requires jaxp_parser
- fixed source perms
- fixed compilation with jsse and javamail
- buildrequires jsse >= 1.0.2-6jpp
- buildrequires javamail >= 1.2-5jpp

* Mon Jun 10 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.1-1jpp
- mx4j 1.1 
- set correct jpackage tags
- add provide jmxri

* Mon Mar 04 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0b3-1jpp
- mx4j 1.0b3 (previous name was openjmx)

* Fri Jan 18 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0b1-1jpp
- first JPackage release


